//index.js
//见https://open.iot.10086.cn/doc/art665.html
//获取应用实例
const app = getApp()
const apikey = '7RB5mJIXUT73JshfnH63sTrpOhg='//API_KEY
const deviceid = '857017149'//设备ID

var deviceConnected = false//初始状态
var number_val=''
var number_val1=false
var number_val2=false

const deviceInfoURL = "https://api.heclouds.com/devices/" + deviceid
const getDataStreamURL = "https://api.heclouds.com/devices/" + deviceid + "/datastreams"
const sendCommandURL = "https://api.heclouds.com/cmds"

function getDeviceInfo(that) {
 
  //查看设备连接状态，并刷新按钮状态
  wx.request({
    url: deviceInfoURL,
    header: {
      'content-type': 'application/x-www-form-urlencoded',
      "api-key": apikey
    },
    data: {

    },
    success(res) {
        
      if (res.data.data.online) {
        console.log("设备已经连接")
        deviceInit(that)//初始化按钮
        deviceConnected = true
      } else {
        console.log("设备还未连接")
        deviceConnected = false
      }
    },
    fail(res) {
      console.log("请求失败")
      deviceConnected = false
    },
    complete() {
      if (deviceConnected) {
        that.setData({ deviceConnected: true })
      } else {
        that.setData({ deviceConnected: false })
      }
    }
  })
}
function deviceInit(that) {
  console.log("开始初始化按钮")
  //初始化各个硬件的状态
  wx.request({
    url: getDataStreamURL,
    header: {
      'content-type': 'application/x-www-form-urlencoded',
      "api-key": apikey
    },
    data: {
      
    },
    success(res) {
      for(var i=0; i<res.data.data.length; i++) {
        var info = res.data.data[i]
        
        switch(info.id) {
         
          case "music1":
            if (info.current_value == 1) {
              that.setData({ sw1: true })
            } else {
              that.setData({ sw1: false })
            }
            break
          case "music2":
            if (info.current_value == 1) {
              that.setData({ sw2: true })
            } else {
              that.setData({ sw2: false })
            }
            break
        }
      }
    }
  })
}

function controlLED(hardware_id ,switch_value) {
  console.log("发送命令：" + hardware_id + ":" +switch_value )
  //按钮发送命令控制硬件
  wx.request({
    url: sendCommandURL + "?device_id=" + deviceid,
    method: 'POST',
    header: {
      'content-type': 'application/x-www-form-urlencoded',
      "api-key": apikey
    },

    data: hardware_id + ":" + switch_value ,
    success(res) {
      console.log("控制成功")
      console.log(res)
    }
  })
}

Page({   
  // 界面显示
  data: {
    temperature:'',
    humidity:''
    },
   //周期函数
  onLoad: function () {

    //加载时完成1.检查设备是否连接2.连接成功将数据显示在界面
    var that = this //将当前对象赋值
    getDeviceInfo(that)
   
//实时获取OneNET发送过来的数据并显示
    setInterval(function () {
      this.init() //不断获取数据显示状态
    }.bind(this), 2000)//刷新时间1s

  },

    //用于获取OneNET发送过来的数据
    init: function () {
      var that = this
      wx.request({
        url: "https://api.heclouds.com/devices/" + deviceid + "/datapoints",   //将请求行中的数字换成自己的设备ID
        header: {
          "api-key": apikey                    //换成自己的api-key
        },
        data: {
          limit: 1
        },
        method: "GET",
        success: function (e) {
          var dat=e.data.data.datastreams[0].datapoints[0].value
          console.log(e.data.data.datastreams[0].datapoints[0].value)//将数据打印输出
          //判断数据是否是0x66
          if(dat==0x66){
             console.log(e.data.data.datastreams[0].datapoints[0].value)
          }
           //判断数据是否是0x44
         else if(dat==0x44){
          console.log(e.data.data.datastreams[0].datapoints[0].value)
         }
        //  实时刷新数据
          that.setData({
            temperature:e.data.data.datastreams[0].datapoints[0].value,
            humidity:e.data.data.datastreams[0].datapoints[0].value
          })
        }
      });
    },
     
  onShow: function() {
    //TODO依旧有问题
    var that = this
    
    var timer = setInterval(function(){
      getDeviceInfo(that)
    }, 2000)
  },

  ch: function (event) {
    var cmdData = event.detail.value == true ? 1 : 0
    Input_value(val,cd)
    
  },
  //获取用户输入的数据
  Input_value(val,cd){
     console.log((val.detail.value))//窗口打印输出
    number_val=(val.detail.value)//转化为数值 
    controlLED(number_val, cd)

    
},

})
